﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Hosting;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using System.IO;
using Syncfusion.Pdf.Parsing;
using Syncfusion.Pdf.Interactive;
using Syncfusion.Drawing;
using Syncfusion.Pdf.Lists;

namespace WebApplication.Controllers
{
    public class HomeController : Controller
    {
        private readonly IHostingEnvironment _hostingEnvironment;
        public HomeController(IHostingEnvironment hostingEnvironment)
        {
            _hostingEnvironment = hostingEnvironment;
        }
        public IActionResult Index()
        {
            return View();
        }
        public IActionResult GeneratePDF()
        {

            //Create a new PDF document.
            PdfDocument document = new PdfDocument();

            //Add a page to the document.
            PdfPage page = document.Pages.Add();


            // set font
            PdfFont font = new PdfStandardFont(PdfFontFamily.Helvetica, 12);

            // create Header
            float pageWidth = document.Pages[0].GetClientSize().Width;

            PdfGraphics graphics = page.Graphics;


            string path = _hostingEnvironment.WebRootPath + "/images/animals.jpg";

            using (Stream imageStream = new FileStream(path, FileMode.Open))
            {
                PdfImage image = PdfImage.FromStream(imageStream);
                graphics.DrawImage(image, new PointF(10, 0), new SizeF(100, 40));


            }





            //Saving the PDF to the MemoryStream
            MemoryStream ms = new MemoryStream();

            //Save the modified document.
            document.Save(ms);

            //Close the document

            document.Close();


            //If the position is not set to '0' then the PDF will be empty.
            ms.Position = 0;

            //Download the PDF document in the browser.
            FileStreamResult fileStreamResult = new FileStreamResult(ms, "application/pdf");
            fileStreamResult.FileDownloadName = "Sample.pdf";
            return fileStreamResult;            
        }


        public IActionResult About()
        {
            ViewData["Message"] = "Your application description page.";

            return View();
        }

        public IActionResult Contact()
        {
            ViewData["Message"] = "Your contact page.";

            return View();
        }

        public IActionResult Error()
        {
            return View();
        }
    }
}
